/*
717361, Alejandro Francés Rubio
717901, Ignacio Bitrián Arcas
--------------------------------
*/

#include <iostream>
#include <iomanip>
#include <random>
#include <math.h> 
#include <fstream>
#include <string>
#include "carretera.h"

using namespace std;


bool extremos_iguales(Carretera v[], int dim, int inter1, int inter2){
	bool ok = false;
	int i = 0;
	while(!ok && i<=dim){
		Carretera c = v[i];
		ok = c.iguales(inter1,inter2);
		i++;
	}
	return ok;
}


void generarProbabilidades(float probabilidades[], int num){
	float aleatorios[num];
	float total=0;
	for (int i=0;i<num;i++){
		float aux=( rand() % ( (100-1) + 1 ) );
		aleatorios[i]=aux;
		total=total+aux;
	}
	
	for (int i = 0; i < num; ++i)
	{
		float x = aleatorios[i]/total;
		probabilidades[i]= roundf(x*10000)/10000;
		
	}
}

void generador(){
	srand (time(NULL));

	ofstream fs;
	fs.open("entradaP1");

	if (fs.is_open()){
		//int N = 100;
		int N = 3 + ( rand() % ( 300 - 3 + 1 ) );	// Número de intersecciones, 3 <= N <= 300
		int M = (N/2) + ( rand() % ( ((N*(N-1))/2) - (N/2) + 1 ) );	// Número de Carreteras, N/2 <= M <= N(N-1)/2
		int C = ( rand() % ( (N-1) + 1 ) );	// Número de intersecciones, 0 <= C < N
		int A = ( rand() % ( (N-1) + 1 ) );	// Número de intersecciones, 0 <= A < N
		while (C == A){
			A = ( rand() % ( (N-1) + 1 ) );
		}
		int B = ( rand() % ( (N-1) + 1 ) );	// Número de intersecciones, 0 <= B < N
		while (A == B){
			B = ( rand() % ( (N-1) + 1 ) );
		}
		fs << N << " " << M << " " << C << " " << A << " " << B << endl;
		
		vector<Carretera> vec[N]; 
		Carretera carre[M];
		for(int i=0; i<M; i++){
			bool ok = true;
			int u,v;
			while(ok){
				u = ( rand() % ( (N-1) + 1 ) );	// Interseccion que une la Carretera i, 0 <= u < N
				v = ( rand() % ( (N-1) + 1 ) );	// INtersección que una la Carretera i, 0 <= v < N
				while (u == v){
					v = ( rand() % ( (N-1) + 1 ) );
				}
				if(i==0){
					ok =false;
				}
				else{
					ok = extremos_iguales(carre,i-1,u,v);
				}
			}
			carre[i] = Carretera(u,v);
			vec[u].push_back(Carretera(u,v));
			vec[v].push_back(Carretera(v,u));
		}

		int numCarreteras[N] = {0};
		for(int i=0; i<N; i++){
			for (auto it = vec[i].begin(); it!=vec[i].end(); it++){ 
				numCarreteras[i]=numCarreteras[i]+1;
			} 
			// calcular x probabilidades
			float probabilidades[numCarreteras[i]];
			generarProbabilidades(probabilidades,numCarreteras[i]);
			for(int j=0; j<numCarreteras[i]; j++){
				int i1 = vec[i].at(j).interseccion_1();
				int i2 = vec[i].at(j).interseccion_2();
				for(int k=0;k<M;k++){
					if(carre[k].interseccion_1()==i1 && carre[k].interseccion_2()==i2) {
						carre[k].probabilidad(probabilidades[j]);
						break;
					}
					else if(carre[k].interseccion_1()==i2 && carre[k].interseccion_2()==i1) {
						carre[k].probabilidad2(probabilidades[j]);
						break;
					}
				}
				vec[i].at(j).probabilidad(probabilidades[j]);
			}
		}


		for(int i=0; i<M; i++){

			int t = 1 + ( rand() % (N/3) );	// Tiempo para recorrer la Carretera i, 1 <= t <= N/3
			int int1, int2;
			float prob1, prob2;
			carre[i].valores(int1,int2,prob1,prob2);
			
			fs << int1 << " " << int2 << " " << t << " " << prob1 << " " << prob2<< endl;
		}

		fs.close();
	}
	else{
		cout << "No se puede acceder al fichero de escritura" << endl;
	}
}


int main(){
	generador();
}